from urllib import request
import json
import os
from bs4 import BeautifulSoup
from jinja2 import Template
from datetime import datetime

template_file = open("template.dot", "r").read()
template = Template(template_file)

# main data objects that will hold all variables
var_title = ""
#var_revisions = []
var_howmany_recentchanges = ""
var_howmany_revisions = ""
var_timestamp = ""
var_total_revisions = ""
var_users = []
var_wiki_url = ""

# how many recentchanges?
howmanyrecentchanges = 2

# how many revisions?
howmanyrevisions = 5

wiki_url = "https://monoskop.org"

# API request: get the latest (howmany?) recentchanges
api_call = f"{wiki_url}/api.php?action=query&list=recentchanges&rclimit={howmanyrecentchanges}&format=json"
data = request.urlopen(api_call).read()
json_data = json.loads(data)
#print(json)
changes = json_data["query"]["recentchanges"]
# print(changes)

for change in changes:
	if change["type"] == "edit":

		# print(change)

		# pageid of this page
		pageid = str(change["pageid"])
		# print(pageid)

		# page title of the page that has been edited
		title = change["title"]
		title_url_safe = title.replace(" ", "_")
		title_safe = title.replace(" ", "_").replace("(","").replace(")","").replace("-","_")
		# print(title)

		# when this edit was made
		timestamp = change["timestamp"]
		# print(timestamp)

		# the graphviz file we will generate
		filename = f"revisions-{title_safe}.dot"
		dot = open(filename, "w")

		# all the revision ids of this page and users who edited this page
		revids = []
		users = []

		var_revisions = []

		# API request: get a list of all revisions
		api_call = f"https://monoskop.org/api.php?action=query&prop=revisions&titles={title_url_safe}&rvstart={timestamp}&rvprop=user|ids&rvlimit={howmanyrevisions}&format=json"
		data = request.urlopen(api_call).read()
		json_data = json.loads(data)
		revisions = json_data["query"]["pages"][pageid]["revisions"]
		# print(json_data)

		# looping through the list of all revisions
		for revision in revisions:

			var_revision = {}

			print("-----")
			# print(f"-- rev: {revision}")
			revid = str(revision["revid"])
			try:
				parentid = str(revision["parentid"])
			except:
				parentid = "0"
			user = revision["user"]
			users.append(user)

			print(title)
			print(revid)
			print(user)

			var_title = title
			var_revision["revid"] = revid
			var_revision["user"] = user
			var_howmany_recentchanges = howmanyrecentchanges
			var_howmany_revisions = howmanyrevisions

			# timestamp_object = datetime.fromisoformat(timestamp)
			# timestamp_string = timestamp_object.strftime('%a %d %b %Y, %I:%M%p')
			# var_timestamp = timestamp_string
			var_timestamp = timestamp

			# API request: get the comment of this revision
			try:
				api_call = f"https://monoskop.org/api.php?action=compare&fromrev={parentid}&torev={revid}&prop=comment&format=json"
				data = request.urlopen(api_call).read()
				json_data = json.loads(data)
				#print(json_data)
				comment_html = json_data["compare"]["fromparsedcomment"]
				comment_soup = BeautifulSoup(comment_html, 'html.parser')
				comment = comment_soup.get_text().replace('"', '')
				print(comment)

				var_revision["comment"] = comment

			except:
				comment = ""

			# add this revision to the list of all revisions
			revids.append(revid)

			var_revisions.append(var_revision)

		# API request: get how many revisions in total this page has
		api_call = f"https://monoskop.org/api.php?action=query&prop=revisions&titles={title_url_safe}&rvstart={timestamp}&rvprop=user|ids&rvlimit=500&format=json"
		data = request.urlopen(api_call).read()
		json_data = json.loads(data)
		total_revisions = len(json_data["query"]["pages"][pageid]["revisions"])

		var_total_revisions = total_revisions
		var_users = users
		var_wiki_url = wiki_url.replace("https://", "")

		print("-----")

		print(var_revisions)
		graph = template.render(title=var_title, revisions=var_revisions, howmanyrevisions=var_howmany_revisions, howmanyrecentchanges=var_howmany_recentchanges, timestamp=var_timestamp, totalrevisions=var_total_revisions, users=var_users, wikiurl=var_wiki_url)
		dot.write(graph)
		dot.close()

		var_revisions = []

		#os.system(f"sh gv-wordwrap.sh {filename} > {filename}")
		os.system(f"dot {filename} -Tpng > {filename}.png")
		print(f"Generated: {filename}")

